godisptmg:
 bsr PutSprite

 or.b d7,d2
 bsr setenmybg
 rts

loadprog:
 bsr clearprogs
 lea curbg(pc),a4
 adda #50,a4
 move.w #49,d5
\loop:
 move.b -(a4),d0
 and.b #$7f,d0
 cmp.w #12,ymap
 bge \nxt
 cmp.b #38,d0
 beq \put1
\nxt:
\backput1:
 dbf d5,\loop
 rts

\put1:
 lea lakepx(pc),a2
 lea lake2px(pc),a3
 bsr putprog
 bra \backput1

putprog:
 move.w d4,d1
 divu.w #10,d1
 move.w d4,d0
 mulu.w #10,d1
 sub.w d1,d0
 divu.w #10,d1
 lsl.w #4,d1
 lsl.w #4,d0
 move.w d0,d2
 move.w d1,d3
 bsr addprog
 rts

addanim:
	move.l #marine,a0
	move.w #$10,d0
	move.w #$10,d1
	jsr (a1)
	rts

clearprogs:
 lea backrts(pc),a1
 move.l #bgprog1,a0
 move.w (a1),(a0)
 move.l a0,bgprogcur1
 move.l #bgprog2,a0
 move.w (a1),(a0)
 move.l a0,bgprogcur2
 rts

addprog:	;1st:	X=d0 Y=d1 adress=a2
		;2nd:	X=d2 Y=d3 adress=a3
		
 move.l bgprogcur1,a0
 lea addanim(pc),a1

 move.w (a1)+,(a0)+
 lea 4(a1),a1
 move.l a2,(a0)+

 move.w (a1)+,(a0)+
 move.w d0,(a0)+
 lea 2(a1),a1
 move.w (a1)+,(a0)+
 move.w d1,(a0)+
 lea 2(a1),a1
 move.w (a1)+,(a0)+
 move.w (a1),(a0)
 move.l a0,bgprogcur1

 move.l bgprogcur2,a0
 lea addanim(pc),a1

 move.w (a1)+,(a0)+
 lea 4(a1),a1
 move.l a3,(a0)+

 move.w (a1)+,(a0)+
 move.w d2,(a0)+
 lea 2(a1),a1
 move.w (a1)+,(a0)+
 move.w d3,(a0)+
 lea 2(a1),a1
 move.w (a1)+,(a0)+
 move.w (a1),(a0)
 move.l a0,bgprogcur2

 rts


WriteStr	macro
 move.w	\3,-(a7)
 pea 	\4(pc)
 move.w	\2,-(a7)
 move.w	\1,-(a7)
 jsr 	tios::DrawStrXY
 lea	10(a7),a7
 endm

loadcoords:
 move.l d7,d0
 mulu.w #192,d0
 move.l #badgbg,a2
 add.l d0,a2

 move.l d7,d0
 mulu.w #8,d0
 lea vars(pc),a0
 add.l d0,a0
 move.w (a0)+,d0
 move.w (a0)+,d1
 move.w (a0)+,d4
 move.w (a0),d2
 rts

hole1:
 cmp.w #12,ymap
 bge nohole
holeok:
 sub.w #2,life
 cmp.w #0,life
 ble dead1
 move.w falloldx,xSprite
 move.w falloldy,ySprite
 move.w fallolddir,direction
 bsr fadeup
 bsr ifenmy
 bsr calcpos
 lea curbg(pc),a6
 bsr bgdisplay
 bsr fadedown
 rts

hole2:
 cmp.w #14,ymap
 ble nohole
 bra holeok

push:
 move.w d4,optch
 and.b #$7f,d5
 cmp.w #37,d5
 beq hole1
 cmp.w #28,d5
 beq hole2
 cmp.w #29,d5
 beq hole2
 cmp.w #23,d5
 beq hole2
 cmp.w #35,d5
 beq hole2

nohole:
 cmp.w #14,ymap
 ble backrts
 cmp.b #11,d5
 bne backrts
 cmp.w #1,pushtrig
 beq nxttrig
 move.w #1,pushtrig
 move.w #1,oddeven
 rts
nxttrig:
 move.w direction,d6
 cmp.w olddir,d6
 bne exitpush
 cmp.w #$8000,oddeven
 beq pushok
 rts
pushok:
 move.b #16,(a1)
 move.l a1,a2
 bsr pushtstalrdy
 cmp.w #0,direction
 beq pushright
 cmp.w #98,direction
 beq pushleft
 cmp.w #194,direction
 beq pushup
 cmp.w #290,direction
 beq pushdown

pushright:
 add.l #1,a1
 btst #7,(a1)
 bne unpush
 move.b #191,(a1)
 bra exitpush
pushleft:
 sub.l #1,a1
 btst #7,(a1)
 bne unpush
 move.b #191,(a1)
 bra exitpush
pushup:
 sub.l #10,a1
 btst #7,(a1)
 bne unpush
 move.b #191,(a1)
 bra exitpush
pushdown:
 add.l #10,a1
 btst #7,(a1)
 bne unpush
 move.b #191,(a1)
 bra exitpush
pushtstalrdy:
 lea curbg(pc),a3
 move.l a1,d0
 sub.l a3,d0
 move.l badgbg,a3
 add.l d0,a3
 cmp.b #1,(a3)
 beq unpush2
 rts
unpush2:
 lea 4(a7),a7
unpush:
 move.b #139,(a2)
exitpush:
 lea curbg(pc),a1
 bsr rerebgdisp
 move.w #0,pushtrig
 move.w optch,d4
 rts

talk:
 lea 4(a7),a7
 bsr timing
 bra dialog

blackrect:
 move.l graphlib::plane0,a0
 move.l graphlib::plane1,a1
 move.w #40,d0
\loop1:
 move.l #$ffffffff,(a0)+
 move.l #$ffffffff,(a0)+
 move.l #$ffffffff,(a0)+
 move.l #$ffffffff,(a0)+
 move.l #$ffffffff,(a0)+
 clr.l (a1)+
 clr.l (a1)+
 clr.l (a1)+
 clr.l (a1)+
 clr.l (a1)+
 add.l #10,a0
 add.l #10,a1
 dbf d0,\loop1
 rts

setenmybg:
 movem.w d0-d1,-(a7)
 and.w #$f0,d0
 lsr.w #4,d0
 and.w #$f0,d1
 lsr.w #4,d1
 mulu.w #10,d1
 add.w d1,d0
 lea enmybg(pc),a0
 add.l d0,a0
 move.b d2,(a0)
 movem.w (a7)+,d0-d1
 rts

exithouse macro
\1
 move.w #$\2,xSprite
 move.w #$\3,ySprite
 move.w #\4,xmap
 move.w #\5,ymap
 bsr ifenmy
 bra housesave
 endm

level macro
\1
 move.w #$\2,xSprite
 move.w #$\3,ySprite
 move.w #\4,xmap
 move.w #\5,ymap
 bsr ifenmy
 bra levelsave
 endm

tstup:
 add.w #2,d1
 cmp.w #2,d1
 ble untstup2
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1

 btst #7,d5
 bne untstup

 add.w #15,d0
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 sub.w #15,d0

 btst #7,d5
 bne untstup
 sub.w #4,d1
 move.w #1,d2
 rts

untstup:
 sub.w #2,d1
 move.w #0,d2
 rts
untstup2:
 sub.w #2,d1
 move.w #-1,d2
 rts


tstdown:
 add.w #16,d1

 cmp.w #64,d1
 bge untstdown2

 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 btst #7,d5
 bne untstdown

 add.w #15,d0
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 sub.w #15,d0

 btst #7,d5
 bne untstdown
 sub.w #14,d1
 move.w #1,d2
 rts

untstdown:
 sub.w #16,d1
 move.w #0,d2
 rts
untstdown2:
 sub.w #16,d1
 move.w #-1,d2
 rts


maxlife:
 move.w lifemax,life
 rts

dtctouch:
 sub.w #14,d1
 move.w ySprite(pc),d2
 cmp.w d1,d2
 bge \under
 rts

\under:
 add.w #28,d1
 cmp.w d1,d2
 ble \over
 rts

\over:
 sub.w #14,d0
 move.w xSprite(pc),d2
 cmp.w d0,d2
 bge \left
 rts

\left
 add.w #28,d0
 cmp.w d0,d2
 ble touched
 rts

touched:
 move.w #0,swordtiming
 cmp.w #0,life
 beq dead
 sub.w #1,life
 bsr displife
 move.w #40,invincible
 cmp.w #0,direction
 beq \righttouch
 cmp.w #98,direction
 beq \lefttouch
 cmp.w #194,direction
 beq \uptouch
 cmp.w #290,direction
 beq \downtouch
 rts

\uptouch:
 add.w #14,ySprite
 move.w xSprite,d0
 move.w ySprite,d1
 bsr tstdown
 cmp.w #1,d2
 beq backrts
 and.w #$f0,ySprite
 rts

\righttouch:
 sub.w #14,xSprite
 move.w xSprite,d0
 move.w ySprite,d1
 bsr tstleft
 cmp.w #1,d2
 beq backrts
 add.w #14,xSprite
 and.w #$f0,xSprite
 rts

\lefttouch:
 add.w #14,xSprite
 move.w xSprite,d0
 move.w ySprite,d1
 bsr tstright
 cmp.w #1,d2
 beq backrts
 and.w #$f0,xSprite
 rts

\downtouch:
 sub.w #14,ySprite
 move.w xSprite,d0
 move.w ySprite,d1
 bsr tstup
 cmp.w #1,d2
 beq backrts
 add.w #14,ySprite
 and.w #$f0,ySprite
 rts

dead:
 lea 4(a7),a7
dead1:

 move.l #gameoverpic,a0
 move.l #screensave0,a1
 move.w #0,d3
 jsr hufflib::extract
 bsr restoreScreen
 bsr pausethegame
 bra exit_game1

dtct:
 move.w d0,d2
 cmp.w #160,d2
 bgt \noppl2
 cmp.w #0,d2
 blt \noppl2

 and.w #$f0,d2
 lsr.w #4,d2
 move.w d1,d3
 cmp.w #80,d2
 bgt \noppl2
 cmp.w #0,d3
 blt \noppl2
 and.w #$f0,d3
 lsr.w #4,d3
 mulu.w #10,d3
 add.w d3,d2
 lea curbg(pc),a1
 add.l d2,a1
 move.b (a1),d5
 rts
\noppl2
 move.b #$80,d5
 rts
dtctpeople:
 move.w d0,d2

 cmp.w #160,d2
 bgt \noppl
 cmp.w #0,d2
 blt \noppl

 and.w #$f0,d2
 lsr.w #4,d2
 move.w d1,d3

 cmp.w #80,d3
 bgt \noppl
 cmp.w #0,d3
 blt \noppl

 and.w #$f0,d3
 lsr.w #4,d3
 mulu.w #10,d3
 add.w d3,d2
 lea enmybg(pc),a1
 add.l d2,a1
 move.b (a1),d5
 rts
\noppl:
 clr.l d5
 rts

clrbadgbg:
 move.w #24,d0
 lea enmybg(pc),a0
\loop:
 clr.w (a0)+
 dbf d0,\loop
 rts

enmydelete:

 mulu.w #4,d5
 lea adressa(pc),a1
 add.l d5,a1
 move.l #backrts,(a1)
 lea adressb(pc),a1
 add.l d5,a1
 move.l #backrts,(a1)
 rts

readenmy:
 move.l (a7)+,a0
 clr.l d0
 move.w (a0)+,d0
loopenmy:
 cmp.w #1,(a0)
 beq enmynbr1
 cmp.w #2,(a0)
 beq people
 cmp.w #3,(a0)
 beq goblinlbl
 cmp.w #4,(a0)
 beq spikelbl

nextenmy:

 dbf d0,loopenmy
 bra endifenmy

goblinlbl:
 lea 2(a0),a0
 move.l d0,d1
 mulu.w #8,d1
 lea vars(pc),a1
 add.l d1,a1
 move.w (a0)+,(a1)+
 move.w (a0)+,(a1)+
 move.l #0,(a1)

 move.l d0,d1
 mulu.w #4,d1
 lea adressa(pc),a1
 add.l d1,a1
 move.l #goblin1a,(a1)

 lea adressb(pc),a1
 add.l d1,a1
 move.l #goblin1b,(a1)

 bra nextenmy


people:
 lea 2(a0),a0

 move.l d0,d1
 mulu.w #4,d1
 lea adressa(pc),a1
 add.l d1,a1
 move.l #anim01a,(a1)

 lea adressb(pc),a1
 add.l d1,a1
 move.l #anim01b,(a1)

 move.l d0,d1
 mulu.w #8,d1
 lea vars(pc),a1
 add.l d1,a1
 move.w (a0)+,(a1)+
 move.w (a0)+,(a1)+
 move.w #1,(a1)+
 move.l (a0)+,(a1)+
 bra nextenmy

spikelbl:
 lea 2(a0),a0
 move.l d0,d1
 mulu.w #8,d1
 lea vars(pc),a1
 add.l d1,a1
 move.w (a0)+,(a1)+
 move.w (a0)+,(a1)+
 move.l #0,(a1)

 move.l d0,d1
 mulu.w #4,d1
 lea adressa(pc),a1
 add.l d1,a1
 move.l #spike1a,(a1)

 lea adressb(pc),a1
 add.l d1,a1
 move.l #badg1b,(a1)

 bra nextenmy


enmynbr1:
 lea 2(a0),a0
 move.l d0,d1
 mulu.w #8,d1
 lea vars(pc),a1
 add.l d1,a1
 move.w (a0)+,(a1)+
 move.w (a0)+,(a1)+
 move.l #0,(a1)

 move.l d0,d1
 mulu.w #4,d1
 lea adressa(pc),a1
 add.l d1,a1
 move.l #badg1a,(a1)

 lea adressb(pc),a1
 add.l d1,a1
 move.l #badg1b,(a1)

 bra nextenmy

clearenmy:
 lea backrts,a0
 lea adressa(pc),a1
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)
 lea adressb(pc),a1
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)+
 move.l a0,(a1)
 rts

tstright:
 add.w #16,d0
 cmp.w #158,d0
 bge untstright2

 add.w #4,d1
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 sub.w #4,d1

 btst #7,d5
 bne untstright

 add.w #15,d1
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 sub.w #15,d1

 btst #7,d5
 bne untstright
 sub.w #14,d0
 move.w #1,d2
 rts

untstright:
 sub.w #16,d0
 move.w #0,d2
 rts
untstright2:
 sub.w #16,d0
 move.w #-1,d2
 rts

tstleft:
 sub.w #2,d0
 cmp.w #-2,d0
 ble untstleft2

 add.w #4,d1
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 sub.w #4,d1

 btst #7,d5
 bne untstleft

 add.w #15,d1
 move.l a1,-(a7)
 bsr dtct
 move.l (a7)+,a1
 sub.w #15,d1

 btst #7,d5
 bne untstleft
 move.w #1,d2
 rts

untstleft:
 add.w #2,d0
 move.w #0,d2
 rts
untstleft2:
 add.w #2,d0
 move.w #-1,d2
 rts


clearGray:
	clr.l	d0
	move.l (graphlib::plane0),a0	;video mem adress into a0
	moveq	#99,d0
\clr	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	lea	10(a0),a0	;next line in the video mem
	dbra	d0,\clr	;repeats
 move.l graphlib::plane1,a0
	moveq	#99,d0
\clr2	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	lea	10(a0),a0	;next line in the video mem

	dbra	d0,\clr2
 rts

restoreScreen:
        move.l a0,-(a7)
        move.l a1,-(a7)
        move.l d0,-(a7)
        move.l #screensave1,a1
        move.l #screensave0,a0
        move.w #LCD_HEIGHT-1,d0
	bra restore

restoreScreen2:
        move.l a0,-(a7)
        move.l a1,-(a7)
        move.l d0,-(a7)
        move.w #79,d0
restore:
        move.l d0,-(a7)
        move.l graphlib::plane1,a2
restoreScreenLoop02:
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        add.l #10,a2
        dbra d0,restoreScreenLoop02
 move.l graphlib::plane0,a2
        move.l (a7)+,d0
restoreScreenLoop12:
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        add.l #10,a2
        dbra d0,restoreScreenLoop12
        move.l (a7)+,d0
        move.l (a7)+,a1
        move.l (a7)+,a0
        rts

savescreen:
        move.l graphlib::plane1,a2
	move.w #79,d0
\loop1:
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        add.l #10,a2
	dbf d0,\loop1
 move.l graphlib::plane0,a2
	move.w #80,d0
\loop2:
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        add.l #10,a2
	dbf d0,\loop2
	rts

savescreenh:
        move.l graphlib::plane1,a2
	move.w #79,d0
\loop1:
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        move.l (a2)+,(a0)+
        add.l #10,a2
        add.l #20,a0
	dbf d0,\loop1
 move.l graphlib::plane0,a2
	move.w #79,d0
\loop2:
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        move.l (a2)+,(a1)+
        add.l #20,a1
        add.l #10,a2
	dbf d0,\loop2
	rts

restoreScreen2h:
        move.l d0,-(a7)
        move.l a0,-(a7)
        move.l a1,-(a7)
        move.l graphlib::plane1,a2
        move.l #79,d0
restoreScreenLoop02h:
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        move.l (a0)+,(a2)+
        add.l #10,a2
        add.l #20,a0
        dbra d0,restoreScreenLoop02h
 move.l graphlib::plane0,a2
        move.l #79,d0
restoreScreenLoop12h:
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        move.l (a1)+,(a2)+
        add.l #10,a2
        add.l #20,a1
        dbra d0,restoreScreenLoop12h
        move.l (a7)+,a1
        move.l (a7)+,a0
        move.l (a7)+,d0
        rts

calcpos:

 move.l #bgmx,a1
 clr.l d0

 move.w ymap,d1
 move.w xmax,d0
 add.w #1,d0
 mulu.w d1,d0
 mulu.w #50,d0
 move.w xmap,d1
 mulu.w #10,d1

 add.w d1,d0
 add.l d0,a1
 rts

pausethegame:
 movem.l d0-d2/a0-a3,-(a7)
 bsr kbrelease
\loop:
 move.w #0,d0
 bsr ReadKBD
 cmp.w #$ff,d0
 beq \loop
 movem.l (a7)+,d0-d2/a0-a3
 rts

fadeup:
	move.w #4,d1
\fadeloop:
	move.w #$b000,d3
	bsr wait
	move.w #9,d0
	trap #9
	jsr (a0)
	dbf d1,\fadeloop
	rts

fadedown:
	move.w #4,d1
\fadeloop2:
	move.w #$b000,d3
	bsr wait
	move.w #10,d0
	trap #9
	jsr (a0)
	dbf d1,\fadeloop2
	rts

midrect:

 move.l graphlib::plane0,a0
 lea 588(a0),a0
 move.l (graphlib::plane1),a1
 lea 588(a1),a1

 lea 14(a1),a1
 or.l #$00ffffff,(a1)+
 move.l #$ffffffff,d0
 move.l d0,(a1)+
 move.l d0,(a1)+
 move.l d0,(a1)+
 lea 14(a0),a0
 and.l #$ff000000,(a0)+
 clr.l (a0)+
 clr.l (a0)+
 clr.l (a0)+
 lea 14(a0),a0
 or.l #$00ffffff,(a0)+
 move.l d0,(a0)+
 move.l d0,(a0)+
 move.l d0,(a0)+
 lea 14(a1),a1
 and.l #$ff000000,(a1)+
 clr.l (a1)+
 clr.l (a1)+
 clr.l (a1)+
 move.w #60,d0
\looprect:
 lea 14(a0),a0
 and.l #$ff000000,(a0)+
 clr.l (a0)+
 clr.l (a0)+
 clr.l (a0)+
 lea 14(a1),a1
 and.l #$ff000000,(a1)+
 clr.l (a1)+
 clr.l (a1)+
 clr.l (a1)+

 dbf d0,\looprect

 lea 14(a0),a0
 or.l #$00ffffff,(a0)+
 move.l #$ffffffff,d0
 move.l d0,(a0)+
 move.l d0,(a0)+
 move.l d0,(a0)+
 lea 14(a1),a1
 and.l #$ff000000,(a1)+
 clr.l (a1)+
 clr.l (a1)+
 clr.l (a1)+
 lea 14(a1),a1
 or.l #$00ffffff,(a1)+
 move.l d0,(a1)+
 move.l d0,(a1)+
 move.l d0,(a1)+
 lea 14(a0),a0
 and.l #$ff000000,(a0)+
 clr.l (a0)+
 clr.l (a0)+
 clr.l (a0)+
 clr.l d0
 rts


SetFont	macro
 move.w	\1,-(a7)
 jsr 	tios::FontSetSys
 lea 	2(a7),a7
 endm

wait:		;d3=0 => megafast
\loopwait:	;d3=$FFFF => megaslow
 nop
 nop
 nop
 dbf d3,\loopwait
 rts

horzline macro	;Y (pxl),X1,X2 (byte)
 move.w \1,d0
 move.w \2,d1
 move.w \3,d2
 bsr horzl
 endm

vertline macro	;X,Y1,Y2 (pxl)
 move.w \1,d0
 move.w \2,d1
 move.w \3,d2
 bsr vertl
 endm


horzl:
 move.l graphlib::plane0,a0
 move.l (graphlib::plane1),a2
 sub.w #1,d2

 mulu.w #30,d0
 add.w d1,d0

 add.w d0,a0
 add.w d0,a2
 sub.w d2,d1
\loop
 move.b #$FF,(a0)+
 move.b #$FF,(a2)+
 dbf d2,\loop
 rts


vertl:
 move.l graphlib::plane0,a0
 move.l (graphlib::plane1),a2

 sub.w d1,d2		;y2-y1=>d2

 mulu.w #30,d1

 move.w d0,d3
 and.w #$fff8,d3
 lsr #3,d3
 add.w d3,d1

 add.w d1,a0		;a0 at the right adress
 add.w d1,a2

 and.w #7,d0		;offset
 move.b #$80,d3		;%1000 0000
 lsr.b d0,d3

\loop:
 or.b d3,(a0)
 lea 30(a0),a0
 or.b d3,(a2)
 lea 30(a2),a2
 dbf d2,\loop
 rts
saveint:
 move.w  #$0700,d0			;redirige int#1
 trap    #1
 move.l  $64,oldint#1
 bclr.b  #2,$600001
 move.l  #newint#1,$64
 bset.b  #2,$600001
 trap    #1
 rts

choose:
 sub.w d5,d3
\loopmenu:
 bsr kbrelease
\loopmenu2:
 move.l #bg2,a2
 lea fairy(pc),a0

 move.w d2,d0

 move.w optch,d1	;y=optch*10+22
 mulu.w d5,d1
 add.w d3,d1

 bsr PutSprite

 bsr pausethegame
 move.w optch,d1	;y=optch*10+22
 mulu.w d5,d1
 add.w d3,d1

 move.w d2,d0

 move.l #bg2,a0		;delete the fairy
 bsr loadSprite

 move.w #%111111011,d0
 bsr ReadKBD

 btst.b #6,d0
 beq \backspace


 move.w #%111111110,d0
 bsr ReadKBD
 btst.b #0,d0
 beq \pos_up
 btst.b #2,d0
 beq \pos_down

 move.w #%111111101,d0
 bsr ReadKBD
 btst #0,d0
 beq \chosen

 move.w #%110111111,d0
;	 move.w #%111101111,d0
 bsr ReadKBD
 btst #0,d0
;	 btst #7,d0
 beq \echap

 bra \loopmenu2

\backspace:
 move.w optch,d0
 move.w #-1,optch
 bra \chosen

\pos_up:
 sub.w #1,optch
 cmp.w #0,optch
 beq \pos_upp
 bra \loopmenu

\pos_down:
 move.w optch,d0
 cmp.w d6,d0
 beq \pos_low
 add.w #1,optch
 bra \loopmenu

\pos_low:
 move.w #1,optch
 bra \loopmenu

\pos_upp:
 move.w d6,optch
 bra \loopmenu

\echap:
 move.w #0,optch
 bra \chosen

\chosen:
 rts
clearlower:
 move.l graphlib::plane0,a0
 move.l (graphlib::plane1),a2
 add.l #2400,a2
 add.l #2400,a0
 move.w #150,d0
\loop:
 clr.l (a0)+
 clr.l (a2)+
 dbf d0,\loop
 horzline #80,#0,#20
 rts

puts:
 mulu.w #30,d1
 add.w d0,d1
 move.l graphlib::plane0,a3
 move.l	(graphlib::plane1),a2
 add.w d1,a3
 add.w d1,a2
 move.b #7,d0
\lop:
 move.b 8(a0),(a2)
 move.b (a0)+,(a3)
 add.l #30,a3
 add.l #30,a2
 dbf d0,\lop
 rts


load:
 lea slot(pc),a0
 add.l d0,a0
 move.w (a0)+,lifemax
 move.w (a0)+,life
 move.w (a0)+,chestvar
 move.w (a0)+,xmap
 move.w (a0)+,ymap
 move.w (a0)+,xSprite
 move.w (a0)+,ySprite
 move.w (a0)+,xold
 move.w (a0)+,yold
 move.w (a0)+,direction
 move.w (a0),money
 rts

saveall:
 lea slot(pc),a0
 add.l d0,a0
 move.w lifemax,(a0)+
 move.w life,(a0)+
 move.w chestvar,(a0)+
 move.w xmap,(a0)+
 move.w ymap,(a0)+
 move.w xSprite,(a0)+
 move.w ySprite,(a0)+
 move.w xold,(a0)+
 move.w yold,(a0)+
 move.w direction,(a0)+
 move.w money,(a0)
 rts

saveabp:
 lea slot(pc),a0
 add.l #66,a0
 move.w lifemax,(a0)+
 move.w life,(a0)+
 move.w chestvar,(a0)
 lea 16(a0),a0
 move.w money,(a0)
 rts

erase:
 lea str1(pc),a0
 mulu.w #8,d0
 add.l d0,a0
 lea str4(pc),a1
 move.l (a1)+,(a0)+
 move.l (a1),(a0)
 divu.w #8,d0
 mulu #22,d0
 move.w d0,d1
 move.l #88,d0
 bsr load
 move.w d1,d0
 bsr saveall
 rts

dispmoney:
;decimal convert

	move.w money,d2
	divu #100,d2
	move.b d2,d5
	lsl.w #4,d5
	lea numer0(pc),a0
	add.l d5,a0

	move.l #93,d1
	move.l #11,d0
	bsr puts

	mulu #100,d2
	move.w money,d3
	sub.w d2,d3
	divu #10,d3

	move.b d3,d5
	lsl.w #4,d5

	lea numer0(pc),a0
	add.l d5,a0


	move.l #93,d1
	move.l #12,d0
	bsr puts


	mulu #10,d3
	move.w money,d0
	sub.w d3,d0
	sub.w d2,d0
		clr.l d5
	move.b d0,d5
	lsl.w #4,d5
	lea numer0(pc),a0
	add.l d5,a0
	move.l #93,d1
	move.l #13,d0
	bsr puts
	rts


PutSprite3:
 movem.l d0-d2/a0-a3,-(a7)
 bsr FindPixel
 moveq #15,d0
\psLoop:
 clr.l d2
 move.w 32(a0),d2
 lsl.l  d1,d2
 or.l d2,(a3)
 clr.l d2
 move.w (a0)+,d2
 lsl.l  d1,d2
 or.l d2,(a1)

 add.w #30,a1
 add.w #30,a3
 dbra d0,\psLoop
 movem.l (a7)+,d0-d2/a0-a3
 rts

displife:
	move.w life,d2
	and.w #$fe,d2
	lsr.w #1,d2
	move.w lifemax,d3
	and.w #$fe,d3
	lsr.w #1,d3
\loop2:
	move.l #83,d1
	move.l #14,d0
	add.w d3,d0
	lea emtyheart(pc),a0
	cmp.w d2,d3
	bgt \pass
	lea heart(pc),a0
\pass:
	bsr puts
	dbf d3,\loop2

	move.w lifemax,d3
	cmp.w #11,d3
	ble \less
	and.w #$fe,d3
	lsr.w #1,d3
	sub.w #6,d3
	sub.w #6,d2

\loop3:
	move.l #91,d1
	move.l #14,d0
	add.w d3,d0
	lea emtyheart(pc),a0
	cmp.w d2,d3
	bgt \pass2
	lea heart(pc),a0
\pass2:
	bsr puts
	dbf d3,\loop3
\less:
	move.w life,d2
	btst.b #0,d2
	bne \loophalf
	and.w #$fe,d2
	lsr.w #1,d2
	move.l #83,d1
	cmp.w #6,d2
	ble \loop4
	move.l #91,d1
	sub.w #6,d2
\loop4:
	move.l #14,d0
	add.w d2,d0
	lea halfheart(pc),a0
	bsr puts
\loophalf
 rts

exit_game1:
 lea 4(a7),a7
exit_game:
 bsr clearGray
 bsr kbrelease
 jsr graphlib::gray2
	SetFont #0
	WriteStr #1,#1,#1,start
	WriteStr #25,#10,#1,start2
	WriteStr #20,#20,#1,start3
	SetFont #1
	WriteStr #10,#40,#1,start4
	WriteStr #10,#50,#1,start5
	WriteStr #10,#60,#1,start6
	WriteStr #10,#80,#1,start7
	WriteStr #10,#90,#1,start8
	WriteStr #30,#70,#1,start9
 bsr pausethegame
 bsr kbrelease
 bsr loadint
 rts
loadint:
 move.w  #$0700,d0			;remet int#1
 trap    #1
 bclr.b  #2,$600001
 move.l  oldint#1(PC),$64
 bset.b  #2,$600001
 trap    #1
 rts



PutSprite2:
 movem.l d0-d2/a0-a3,-(a7)
 tst.w d0
 bmi ClipLeft2
 bsr FindPixel			;coordinates d0,d1 -> (a1) & bit offset d1
 moveq #15,d0			;loop 15 times in normal PutSprite
psLoop2:
 cmp.l (graphlib::plane0),a1
 ble \next
 move.l (a3),64(a2)
 move.l (a1),(a2)		;store longword of background
 clr.l d2				;clear upperword
 move.w 64(a0),d2		;sprite mask into d2
 lsl.l d1,d2			;shift it by complemented bit offset
 not.l d2				;complement mask
 and.l d2,(a1)			;clear unwanted bits
 and.l d2,(a3)
 clr.l d2				;clear upperword
 move.w 32(a0),d2
 lsl.l d1,d2
 or.l d2,(a3)
 clr.l d2
 move.w (a0),d2		;get current byte of sprite
 lsl.l d1,d2			;shift it by complemented bit offset
 or.l d2,(a1)			;and or it to memory
\next:
 add.l #2,a0
 add.l #4,a2
 add.w #30,a1			;point to next row
 add.w #30,a3
 dbra d0,psLoop2			;continue until sprite drawn
 movem.l (a7)+,d0-d2/a0-a3
 rts

ClipLeft2:
 neg.w d0				;make d0 positve
 move.w d0,d2			;store it in d3
 clr.w d0				;clear upperword
 bsr FindPixel			;coordinates d0,d1 -> (a1) & bit offset d1
 add.w d2,d1			;add negated x to bitoffset for new bit offset
 moveq #15,d0			;loop 16 times
 bra psLoop2


loadSprite2:
 movem.l d0-d2/a0-a1/a3,-(a7)
 tst.w d0
 bmi ldClipLeft2

 bsr FindPixel
 moveq #15,d0
ldLoop2:
 cmp.l graphlib::plane0,a1
 ble \nxt
 move.l 64(a0),(a3)
 move.l (a0),(a1)
\nxt:
 add.l #4,a0
 add.w #30,a1
 add.w #30,a3
 dbra d0,ldLoop2
 movem.l (a7)+,d0-d2/a0-a1/a3
 rts

ldClipLeft2:
 clr.w d0
 bsr FindPixel
 moveq #15,d0
 bra ldLoop2


ClipLeftinv:
 neg.w d0				;make d0 positve
 move.w d0,d2			;store it in d3
 clr.w d0				;clear upperword
 bsr FindPixel			;coordinates d0,d1 -> (a1) & bit offset d1
 add.w d2,d1			;add negated x to bitoffset for new bit offset
 moveq #15,d0			;loop 16 times
 bra psLoopinv


PutSpriteinv:
 movem.l d0-d2/a0-a3,-(a7)
 tst.w d0
 bmi ClipLeftinv
 bsr FindPixel			;coordinates d0,d1 -> (a1) & bit offset d1
 moveq #15,d0			;loop 15 times in normal PutSprite
psLoopinv:
 cmp.l (graphlib::plane0),a1
 ble \next
 move.l (a3),64(a2)
 move.l (a1),(a2)		;store longword of background
 clr.l d2			;clear upperword
 clr.l d3
 move.w 64(a0),d3		;sprite mask into d2
 lsl.l d1,d3			;shift it by complemented bit offset
 not.l d3				;complement mask
 and.l d3,(a3)			;clear unwanted bits
 and.l d3,(a1)
 not.l d3
 move.w 32(a0),d2
 lsl.l d1,d2
 eor.l d3,d2
 or.l d2,(a1)
 clr.l d2
 move.w (a0),d2		;get current byte of sprite
 lsl.l d1,d2			;shift it by complemented bit offset
 eor.l d3,d2
 or.l d2,(a3)			;and or it to memory

\next:
 add.l #2,a0
 add.l #4,a2
 add.w #30,a1			;point to next row
 add.w #30,a3
 dbra d0,psLoopinv			;continue until sprite drawn
 movem.l (a7)+,d0-d2/a0-a3
 rts

PutSprite:
 movem.l d0-d2/a0-a3,-(a7)
 bsr FindPixel			;coordinates d0,d1 -> (a1) & bit offset d1
 moveq #15,d0			;loop 15 times in normal PutSprite
psLoop:
 move.l (a3),64(a2)
 move.l (a1),(a2)+		;store longword of background
 clr.l d2				;clear upperword
 move.w 64(a0),d2		;sprite mask into d2
 lsl.l d1,d2			;shift it by complemented bit offset
 not.l d2				;complement mask
 and.l d2,(a1)			;clear unwanted bits
 and.l d2,(a3)
 clr.l d2				;clear upperword
 move.w 32(a0),d2
 lsl.l d1,d2
 or.l d2,(a3)
 clr.l d2
 move.w (a0)+,d2		;get current byte of sprite
 lsl.l d1,d2			;shift it by complemented bit offset
 or.l d2,(a1)			;and or it to memory

 add.w #30,a1			;point to next row
 add.w #30,a3
 dbra d0,psLoop			;continue until sprite drawn
 movem.l (a7)+,d0-d2/a0-a3
 rts


loadSprite:
 movem.l d0-d2/a0-a1/a3,-(a7)
 bsr FindPixel
 moveq #15,d0
ldLoop:
 move.l 64(a0),(a3)
 move.l (a0)+,(a1)
 add.w #30,a1
 add.w #30,a3
 dbra d0,ldLoop
 movem.l (a7)+,d0-d2/a0-a1/a3
 rts

FindPixel:
 move.l graphlib::plane0,a1
 mulu.w #30,d1			;multiply x coordinate by 30 (30 bytes in each row)
 move.w d1,-(a7)		;add it to video mem
 move.b d0,d1			;store y coordinate
 and.w #$fff0,d0		;
 lsr.b #3,d0			;divide by 8 (8 pixels in a byte)
 add.w d0,(a7)			;add it to video mem
 and.b #15,d1			;bottom 4 bits -> bit offset
 eori.b #15,d1			;but inverted
 move.l (graphlib::plane1),a3
 add.w (a7),a1
 add.w (a7)+,a3

 rts

userlib::random:
        move.l  d1,-(a7)
	move.w	rand_seed(pc),d1
	mulu.w	#31421,d1
	add.w	#6927,d1
	mulu.w	d1,d0
	move.w	d1,rand_seed
	clr.w	d0
	swap	d0
        move.l  (a7)+,d1
	rts
rand_seed	dc.w	0